/*
 * File: TsmInterfaces.h
 * Date: 20 aug 2011
 * Time: 14:12:10
 * Generated by TismTool version 0.7
 */

#ifndef TSM_INTERFACES_H
#define TSM_INTERFACES_H

#include "TsmBase.h"
#include "TsmTrigger.h"
#include "TsmInterfacePort.h"
using namespace std;
using namespace TsmRTE;

namespace Calculator
{

  class ICalculator
  {
  public:
    virtual void Cancel() = 0;
    virtual void CancelEntry() = 0;
    virtual void Digit_0() = 0;
    virtual void Digit_1_9( char digitId ) = 0;
    virtual bool Equals() = 0;
    virtual void Off() = 0;
    virtual bool Oper( char operId ) = 0;
    virtual void Point() = 0;
  };

  class TsmTrigger_ICalculator___Cancel : public TsmTrigger
  {
  public:
    TsmTrigger_ICalculator___Cancel()
      : TsmTrigger( 1 )
    {
    }
  };

  class TsmTrigger_ICalculator___CancelEntry : public TsmTrigger
  {
  public:
    TsmTrigger_ICalculator___CancelEntry()
      : TsmTrigger( 2 )
    {
    }
  };

  class TsmTrigger_ICalculator___Digit_0 : public TsmTrigger
  {
  public:
    TsmTrigger_ICalculator___Digit_0()
      : TsmTrigger( 3 )
    {
    }
  };

  class TsmTrigger_ICalculator___Digit_1_9 : public TsmTrigger
  {
  public:
    char digitId;

    TsmTrigger_ICalculator___Digit_1_9( char digitId )
      : TsmTrigger( 4 )
      , digitId( digitId )
    {
    }
  };

  class TsmTrigger_ICalculator___Equals : public TsmTrigger
  {
  public:
    bool _RetVal;

    TsmTrigger_ICalculator___Equals()
      : TsmTrigger( 5 )
    {
    }
  };

  class TsmTrigger_ICalculator___Off : public TsmTrigger
  {
  public:
    TsmTrigger_ICalculator___Off()
      : TsmTrigger( 6 )
    {
    }
  };

  class TsmTrigger_ICalculator___Oper : public TsmTrigger
  {
  public:
    char operId;
    bool _RetVal;

    TsmTrigger_ICalculator___Oper( char operId )
      : TsmTrigger( 7 )
      , operId( operId )
    {
    }
  };

  class TsmTrigger_ICalculator___Point : public TsmTrigger
  {
  public:
    TsmTrigger_ICalculator___Point()
      : TsmTrigger( 8 )
    {
    }
  };

   // ( Xmi > Data > Protocols > CalculatorProtocol > ICalculator )
  class TsmIPort_ICalculator : public TsmInterfacePort, public ICalculator
  {
  public:
    TsmIPort_ICalculator( TsmBase* oParent )
    {
      TsmName = "ICalculator";
      TsmParent = oParent;
    }

    void Cancel()
    {
      bool bDBC;
      TsmTrigger_ICalculator___Cancel* tt = new TsmTrigger_ICalculator___Cancel;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void CancelEntry()
    {
      bool bDBC;
      TsmTrigger_ICalculator___CancelEntry* tt = new TsmTrigger_ICalculator___CancelEntry;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Digit_0()
    {
      bool bDBC;
      TsmTrigger_ICalculator___Digit_0* tt = new TsmTrigger_ICalculator___Digit_0;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    void Digit_1_9( char digitId )
    {
      bool bDBC;
      TsmTrigger_ICalculator___Digit_1_9* tt = new TsmTrigger_ICalculator___Digit_1_9( digitId );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    bool Equals()
    {
      bool bDBC;
      bool _RetVal;
      TsmTrigger_ICalculator___Equals* tt = new TsmTrigger_ICalculator___Equals;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Off()
    {
      bool bDBC;
      TsmTrigger_ICalculator___Off* tt = new TsmTrigger_ICalculator___Off;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }

    bool Oper( char operId )
    {
      bool bDBC;
      bool _RetVal;
      TsmTrigger_ICalculator___Oper* tt = new TsmTrigger_ICalculator___Oper( operId );
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      _RetVal = tt->_RetVal;
      if ( bDBC )
      {
        delete tt;
      }
      return _RetVal;
    }

    void Point()
    {
      bool bDBC;
      TsmTrigger_ICalculator___Point* tt = new TsmTrigger_ICalculator___Point;
      tt->PortId = this->PortId;
      bDBC = this->Messager->Handle( tt );
      if ( bDBC )
      {
        delete tt;
      }
    }
  };
}
#endif
