﻿/*
 * TismTool � Tis Veugen, 2010-2011
 *
 * View.cpp
 * version 1
 */

#include <iostream>
#include <sstream>
#include <cstdio>
#include "View.h"
#include "TsmSystem.h"
#include "TsmInterfaces.h"
using namespace std;
using namespace TsmRTE;

namespace Calculator
{
  string View::sAll = "";
  char   View::cOper;
  double View::dPrevious;
  double View::dValue;

  bool View::Evaluate()
  {
    Convert();

    switch ( cOper )
    {
    case '+' :
      dValue = dPrevious + dValue;
      break;
    case '-' :
      dValue = dPrevious - dValue;
      break;
    case '*' :
      dValue = dPrevious * dValue;
      break;
    case '/' :
      if ( 0.0 == dValue )
      {
        Show( "Error" );
        return false;
      }
      dValue = dPrevious / dValue;
      break;
    }
    stringstream ss;
    ss << "" << dValue;
    Show( ss.str() );
    return true;
  }

  void View::Show()
  {
    string s = "";

    if ( sAll.size() == 0 )
    {
      s += "0";
    }
    else
    {
      s += sAll;
    }
    Show( s );
  }

  void View::TsmRun( void* oObject )
  {
    TsmIPort_ICalculator* Port = static_cast<TsmIPort_ICalculator*>(oObject);

    bool bPrompt = true;
    // MyCode
    for ( ; ; )
    {
      if ( bPrompt )
      {
        cout << "> ";
      }
      bPrompt = true;
      char c = getchar();

      switch ( c )
      {
      case '+':
      case '-':
      case '*':
      case '/':
        Port->Oper( c );
        break;
      case '=':
        Port->Equals();
        break;
      case '.':
        Port->Point();
        break;
      case '0':
        Port->Digit_0();
        break;
      case '1':
      case '2':
      case '3':
      case '4':
      case '5':
      case '6':
      case '7':
      case '8':
      case '9':
        Port->Digit_1_9( c );
        break;
      case 'e':
        Port->CancelEntry();
        break;
      case 'c':
        Port->Cancel();
        break;
      case 'q':
        Port->Off();
        return;
        //break;

      case '\0':
        break;
      case '\r':  // flush buffer
      case '\n':  // flush buffer
        bPrompt = false;
        break;
      default:
        stringstream ss;
        ss  << "Illegal input: " << c;
        cout << ss.str() << endl;
        break;
      }
    }
  }
}
