﻿/*
 * TismTool � Tis Veugen, 2010-2011
 *
 * View.h
 * version 1
 */

#ifndef CALCULATOR_VIEW_H
#define CALCULATOR_VIEW_H

#include <iostream>
#include <sstream>
#include <cstdio>
using namespace std;

namespace Calculator
{
  class View
  {
  private:
    static string sAll;
    static char   cOper;
    static double dPrevious;
    static double dValue;

    static void Clear()
    {
      sAll = "";
    }

  public:
    static void CancelEntry()
    {
      dValue = 0.0;
      Clear();
      Show();
    }

    static void Convert()
    {
      istringstream iss(sAll);
      iss >> dValue;

      Clear();
    }

    static void Insert( char keyId )
    {
      stringstream ss;
      ss << sAll << keyId;
      sAll = ss.str();
      Show();
    }

    static void Inserts( string keyIds )
    {
      sAll += keyIds;
      Show();
    }

    static void Negate()
    {
      sAll = "-";
      Show();
    }

    static void Oper( char keyId )
    {
      dPrevious = dValue;
      cOper = keyId;
    }

    static bool Evaluate();

    static void Show();

    static void Show( string s )
    {
      cout << s << endl;
    }

    static void Exit()
    {
      Show( "Exit (reached final state)" );
    }

    static void TsmRun( void* oObject );
  };
}
#endif
