/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * TsmComponent.cpp
 * version 4
 */

#include "TsmComponent.h"
#include "TsmInterfacePort.h"
using namespace std;

namespace TsmRTE
{
  TsmComponent::~TsmComponent()
  {
    if ( mNrClasses > 0 )
    {
      for ( int i=0; i<mNrClasses; i++ )
      {
        delete mClasses[i];
      }
      delete [] mClasses;
    }

    if ( mNrComponents > 0 )
    {
      for ( int i=0; i<mNrComponents; i++ )
      {
        delete mComponents[i];
      }
      delete [] mComponents;
    }
  }

  void TsmComponent::TsmInitialiseAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmInitialise( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmInitialiseAll( oObject );
    }

    this->TsmInitialise( oObject );
  }

  void TsmComponent::TsmConnectAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmConnect( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmConnectAll( oObject );
    }

    this->TsmConnect( oObject );
  }

  void TsmComponent::TsmPrepareAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmPrepare( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmPrepareAll( oObject );
    }

    this->TsmPrepare( oObject );
  }

  void TsmComponent::TsmRunAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmRun( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmRunAll( oObject );
    }

    this->TsmRun( oObject );
  }

  void TsmComponent::TsmHaltAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmHalt( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmHaltAll( oObject );
    }

    this->TsmHalt( oObject );
  }

  void TsmComponent::TsmCeaseAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmCease( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmCeaseAll( oObject );
    }

    this->TsmCease( oObject );
  }

  void TsmComponent::TsmDisconnectAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmDisconnect( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmDisconnectAll( oObject );
    }

    this->TsmDisconnect( oObject );
  }

  void TsmComponent::TsmTerminateAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmTerminate( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmTerminateAll( oObject );
    }

    this->TsmTerminate( oObject );
  }

  void TsmComponent::TsmMentionAll( void* oObject )
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmMention( oObject );
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmMentionAll( oObject );
    }
  }

  void TsmComponent::TsmCheckVisitAll()
  {
    int i;

    for ( i = 0; i < mNrClasses; i++ )
    {
      mClasses[i]->TsmCheckVisit();
    }
    for ( i = 0; i < mNrComponents; i++ )
    {
      mComponents[i]->TsmCheckVisitAll();
    }
  }

  void TsmComponent::DoAssembly( TsmClass* Client, string sRequired, TsmClass* Server, string sProvided )
  {
    TsmInterfacePort* lPort;

    lPort = Server->GetProvidedInterface( sProvided );
    Client->SetRequiredInterface( sRequired, lPort );
  }
}
