/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * TsmExecComponent.h
 * version 1
 */
#ifndef TSM_EXECCOMPONENT_H
#define TSM_EXECCOMPONENT_H

#include "TsmComponent.h"
#include "TsmSupervisor.h"
#include "TsmIntQueue.h"
using namespace std;

namespace TsmRTE
{
  /**
   * Executable Component
   */
  class TsmExecComponent : public TsmComponent
  {
  public:
    void Activate()
    {
      TsmSupervisor::Initialise();
      TsmIntQueue* lIntQueue = TsmSupervisor::GetIntQueue();

      TsmInitialiseAll( NULL );
      TsmConnectAll( lIntQueue );
      TsmPrepareAll( NULL );
      TsmRunAll( NULL );
    }

    void Execute()
    {
      TsmSupervisor::Execute();
    }

    void Deactivate()
    {
      TsmHaltAll( NULL );
      TsmCeaseAll( NULL );
      TsmDisconnectAll( NULL );
      TsmTerminateAll( NULL );

      TsmSupervisor::Terminate();
    }
  };
}
#endif
