/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * Tsm.cpp
 * version 2
 */
#include <iomanip>
#include <fstream>
#include <boost/thread/locks.hpp>
#include "Tsm.h"
using namespace std;

namespace TsmRTE
{
  bool Tsm::mbLogConsole  = false;
  bool Tsm::mbLogFile     = true;
  int  Tsm::mLogLevel     = 1;

  ofstream      Tsm::mLogWriter;
  boost::mutex  Tsm::mLogLockMutex;

  void Tsm::Open()
  {
    if ( mbLogFile )
    {
      string s = FreeTismFile( "Log" );
      mLogWriter.open( s.c_str(), ios::out );
      if ( mLogWriter.fail() )
      {
        cout << "ERROR: opening file: " << s;
      }
    }
  }

  void Tsm::Log( string s )
  {
    boost::unique_lock<boost::mutex> lock( mLogLockMutex );

    if ( mLogWriter )
    {
      mLogWriter << s << endl;
      mLogWriter.flush();
    }

    if ( mbLogConsole )
    {
      cout << s << endl;
    }
  }

  void Tsm::Close()
  {
    if ( mLogWriter )
    {
      mLogWriter.close();
    }
  }

  string Tsm::FreeTismFile( string sName )
  {
    ifstream fi;
    string s;
    int ix = 0;

    for ( ; ; )
    {
      stringstream sb;

      ix++;
      sb.fill( '0' );
      sb << "Tism" << sName << "_" << setw(4) << ix << ".txt";
      s = sb.str();
      fi.open( s.c_str(), ios::in );
      if ( fi.fail() )
      {
        break;
      }
      fi.close();
    }

    return s;
  }
}
