/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmTrigger.h
 * version 7
 */
#ifndef TSM_TRIGGER_H
#define TSM_TRIGGER_H

#include <sstream>
#include <typeinfo>
#include "TsmRvState.h"
#include "TsmRecorder.h"
using namespace std;

namespace TsmRTE
{
  /**
   * Trigger message
   */
  class TsmTrigger
  {
  private:
    bool        bDBU; /* DeleteByUser */

  public:
    int         PortId;
    int         Command;
    TsmRvState  RvState;

    TsmTrigger( int iCmd )
      : bDBU( false )
      , Command( iCmd )
      , RvState( IDLE )
    {
    }

    virtual ~TsmTrigger()
    {
    }

    void Ready()
    {
      switch ( RvState )
      {
      case IDLE:
        TsmRecorder::SyncReturnError( "**** RENDEZ-VOUS IDLE " );
        break;

      case WAIT:
        RvState = READY;
        break;

      case READY:
        TsmRecorder::SyncReturnError( "**** RENDEZ-VOUS READY " );
        break;
      }
    }

    string Snap()
    {
      stringstream ss;
      ss << " " << PortId << "." << Command;
      return ss.str();
    }

    virtual string ClassName()
    {
      return typeid( *this ).name();
    }

    void SetDBU()
    {
      this->bDBU = true;
    }

    void DBU()
    {
      if ( this->bDBU )
      {
        delete this;
      }
    }

    void DBC()
    {
      if ( ! this->bDBU )
      {
        delete this;
      }
    }
  };
}
#endif
