/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmHandlerAction.h
 * version 1
 */
#ifndef TSM_HANDLERACTION_H
#define TSM_HANDLERACTION_H

using namespace std;

namespace TsmRTE
{
  class TsmHandlerAction
  {
  public:
    static const int NONE          = 0;
    static const int NOK           = 1;
    static const int FINAL         = 2;
    static const int GUARD         = 4;
    static const int OK            = 8;
    static const int TRANSITION    = 16;
    static const int ENTER         = 32;
    static const int INITIAL       = 64;
    static const int ENTRYPOINT    = 128;
    static const int QUIT          = 256;
    static const int EXITPOINT     = 512;
    static const int TACTRANSITION = 1024;

    static bool hasTransition( int action )
    {
      int v = TsmHandlerAction::TRANSITION
        | TsmHandlerAction::TACTRANSITION;
      return (action & v) != 0;
    }

    static bool isFinalNok( int action )
    {
      int v = TsmHandlerAction::FINAL
        | TsmHandlerAction::NOK;    
      return action == v;
    }
  };
}
#endif
