/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * TsmState.cpp
 * version 1
 */
#include <sstream>
#include "TsmState.h"
#include "TsmHandler.h"
#include "TsmException.h"
using namespace std;

namespace TsmRTE
{
  void TsmState::ExecuteHandler( TsmHandler& oHandler )
  {
    bool bReady = false;

    do
    {
      switch ( oHandler.Action )
      {
      case TsmHandlerAction::TRANSITION:
      case TsmHandlerAction::TACTRANSITION:
        bReady = ExecuteTransition( oHandler );
        break;
      case TsmHandlerAction::EXITPOINT:
        oHandler.Action = TsmHandlerAction::TRANSITION;
        bReady = true;
        break;
      case TsmHandlerAction::ENTER:
        AtEntry( oHandler );
        Initial( oHandler );
        break;
      case TsmHandlerAction::INITIAL:
        Initial( oHandler );
        break;
      case TsmHandlerAction::ENTRYPOINT:
        AtEntry( oHandler );
        Entrypoint( oHandler );
        break;
      case TsmHandlerAction::OK:
      case TsmHandlerAction::GUARD:
      case TsmHandlerAction::NOK:
        bReady = true;
        break;
      case TsmHandlerAction::FINAL:
      case TsmHandlerAction::QUIT:
        ExecuteTriggerless( oHandler );
        bReady = true;
        break;
      default :
        stringstream sb;
        sb << "TsmHandlerAction '" << oHandler.Action << "' @ " << this->FullName();
        throw TsmException( sb.str() );
        //break;
      }
    } while ( ! bReady );
  }

  void TsmState::ExecuteTrigger( TsmHandler& oHandler )
  {
    // N.B. Some states may have no triggers
    oHandler.Action = TsmHandlerAction::NOK;
  }

  void TsmState::ExecuteTriggerless( TsmHandler& oHandler )
  {
    oHandler.Action = TsmHandlerAction::NOK;
  }

  void TsmState::TsmCheckVisit()
  {
  }
}
