/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * TsmCbThread.cpp
 * version 3
 */
#include "TsmCbThread.h"
#include "TsmThreadType.h"
#include "TsmSupervisor.h"
#include "TsmEnvelope.h"
#include "TsmRvState.h"
using namespace std;

namespace TsmRTE
{
  void TsmCbThread::Prepare()
  {
    mbHalt = false;
    mThread = new boost::thread( CbWorker, this );
    mSequence = TsmSupervisor::Register( this, mType );
    this->setName( "TismRTE" );
  }

  void TsmCbThread::NativeCall( TsmEnvelope& oEnvelope )
  {
    oEnvelope.getTrigger()->SetDBU();
    mExternalQueue->Put( oEnvelope );
  }

  void TsmCbThread::CbHandle( TsmEnvelope& oEnvelope )
  {
    oEnvelope.getTarget()->ExecuteNative( oEnvelope.getTrigger()->Command );
  }

  void CbWorker( TsmCbThread* oTsmThread )
  {
    TsmEnvelope   lEnvelope;
    bool          bMsg = false;

    oTsmThread->RendezVousWait();

    while ( ! oTsmThread->mbHalt )
    {
      oTsmThread->TriggerWait();

      if ( oTsmThread->mExternalQueue->Dequeue( lEnvelope ) )
      {
        try
        {
          oTsmThread->CbHandle( lEnvelope );
        }
        catch ( exception& e )
        {
          Tsm::ShowException( "@q", e );
        }
        lEnvelope.getTrigger()->DBU();
      }

      do
      {
        bMsg = false;
        if ( oTsmThread->mInternalQueue->Dequeue( lEnvelope ) )
        {
          bMsg = true;
          try
          {
            oTsmThread->Handle( lEnvelope );
          }
          catch ( exception& e )
          {
            Tsm::ShowException( "@s", e );
          }
          lEnvelope.getTrigger()->DBU();
        }
      } while ( bMsg );
    }
  }  
}
