/*
 * TismTool © Tis Veugen, 2010-2011
 * Application, Simulation, Verification
 *
 * TsmMutex.h
 * version 1
 */
#ifndef TSM_MUTEX_H
#define TSM_MUTEX_H

#include <boost/thread/condition_variable.hpp>
#include <boost/thread/mutex.hpp>    
#include <boost/thread/locks.hpp>
using namespace std;

namespace TsmRTE
{
  class TsmMutex
  {
  protected:
    bool                      mbExclusive;
    int                       mCount;
    boost::mutex              mMutex;
    boost::condition_variable mCondVar;

  public:
    TsmMutex()
      : mbExclusive( false )
      , mCount( 1 )
    {
    }

    void WaitOne()
    {
      //TsmAssert( ! mbExclusive );
      boost::unique_lock<boost::mutex> lock( mMutex );
      while ( mCount == 0 )
      {
        mCondVar.wait( lock );
      }
      --mCount;
      mbExclusive = true;    
    }

    void ReleaseMutex()
    {
      mbExclusive = false;
      boost::unique_lock<boost::mutex> lock( mMutex );
      ++mCount;
      mCondVar.notify_one();
    }
  };
}
#endif
