/*
 * TismTool © Tis Veugen, 2010-2011
 * Application
 *
 * TsmSupervisor.cpp
 * version 3
 */
#include <boost/date_time.hpp>
#include <boost/thread/thread.hpp>
#include "TsmSupervisor.h"
#include "TsmCbThread.h"
#include "TsmThread.h"
#include "Tsm.h"
using namespace std;

namespace TsmRTE
{
  TsmActivity*  TsmSupervisor::mActivity;
  int           TsmSupervisor::mThreadId = 0;
  TsmCbThread*  TsmSupervisor::mCbThread;

  void TsmSupervisor::Initialise()
  {
    Tsm::Open();
    mActivity = new TsmActivity();
    Register( NULL, SUPERVISOR );

    mCbThread = new TsmCbThread();
    mCbThread->Prepare();
    mCbThread->Run();
  }

  void TsmSupervisor::Terminate()
  {
    mCbThread->Halt();
    mCbThread->Cease();
    delete mCbThread;
    delete mActivity;
    Tsm::Close();
  }

  TsmIntQueue* TsmSupervisor::GetIntQueue()
  {
    return mCbThread->getIntQueue();
  }

  void TsmSupervisor::Announce()
  {
    mActivity->Announce();
  }

  void TsmSupervisor::Abandon()
  {
    mActivity->Abandon();
  }

  int TsmSupervisor::Register( TsmThread* oTsmThread )
  {
    return Register( oTsmThread, THREAD );
  }

  int TsmSupervisor::Register( TsmThread* oTsmThread, TsmThreadType eType )
  {
    return mThreadId++;
  }

  void TsmSupervisor::Execute()
  {
    mActivity->Wait();
    /*
     * Grant threads time to sleep.
     */
    boost::posix_time::milliseconds ms(10);
    boost::this_thread::sleep( ms );
  }
}
